{-#LANGUAGE TupleSections #-}
module Text.Tamper.Tags.Html.Attributes
where

import Data.Monoid

-- HTML5 attributes

accept = ("accept",)
acceptCharset = ("accept-charset",)
accesskey = ("accesskey",)
action = ("action",)
alt = ("alt",)
async = ("async",)
autocomplete = ("autocomplete",)
autofocus = ("autofocus",)
autoplay = ("autoplay",)
challenge = ("challenge",)
charset = ("charset",)
checked = ("checked",)
cite = ("cite",)
class_ = ("class",)
cols = ("cols",)
colspan = ("colspan",)
content = ("content",)
contenteditable = ("contenteditable",)
contextmenu = ("contextmenu",)
controls = ("controls",)
coords = ("coords",)
data_ = ("data",)
datetime = ("datetime",)
defer = ("defer",)
dir = ("dir",)
disabled = ("disabled",)
draggable = ("draggable",)
enctype = ("enctype",)
for = ("for",)
form = ("form",)
formaction = ("formaction",)
formenctype = ("formenctype",)
formmethod = ("formmethod",)
formnovalidate = ("formnovalidate",)
formtarget = ("formtarget",)
headers = ("headers",)
height = ("height",)
hidden = ("hidden",)
high = ("high",)
href = ("href",)
hreflang = ("hreflang",)
httpEquiv = ("http-equiv",)
icon = ("icon",)
id = ("id",)
ismap = ("ismap",)
item = ("item",)
itemprop = ("itemprop",)
keytype = ("keytype",)
label = ("label",)
lang = ("lang",)
list = ("list",)
loop = ("loop",)
low = ("low",)
manifest = ("manifest",)
max = ("max",)
maxlength = ("maxlength",)
media = ("media",)
method = ("method",)
min = ("min",)
multiple = ("multiple",)
name = ("name",)
novalidate = ("novalidate",)
onbeforeonload = ("onbeforeonload",)
onbeforeprint = ("onbeforeprint",)
onblur = ("onblur",)
oncanplay = ("oncanplay",)
oncanplaythrough = ("oncanplaythrough",)
onchange = ("onchange",)
oncontextmenu = ("oncontextmenu",)
onclick = ("onclick",)
ondblclick = ("ondblclick",)
ondrag = ("ondrag",)
ondragend = ("ondragend",)
ondragenter = ("ondragenter",)
ondragleave = ("ondragleave",)
ondragover = ("ondragover",)
ondragstart = ("ondragstart",)
ondrop = ("ondrop",)
ondurationchange = ("ondurationchange",)
onemptied = ("onemptied",)
onended = ("onended",)
onerror = ("onerror",)
onfocus = ("onfocus",)
onformchange = ("onformchange",)
onforminput = ("onforminput",)
onhaschange = ("onhaschange",)
oninput = ("oninput",)
oninvalid = ("oninvalid",)
onkeydown = ("onkeydown",)
onkeyup = ("onkeyup",)
onload = ("onload",)
onloadeddata = ("onloadeddata",)
onloadedmetadata = ("onloadedmetadata",)
onloadstart = ("onloadstart",)
onmessage = ("onmessage",)
onmousedown = ("onmousedown",)
onmousemove = ("onmousemove",)
onmouseout = ("onmouseout",)
onmouseover = ("onmouseover",)
onmouseup = ("onmouseup",)
onmousewheel = ("onmousewheel",)
ononline = ("ononline",)
onpagehide = ("onpagehide",)
onpageshow = ("onpageshow",)
onpause = ("onpause",)
onplay = ("onplay",)
onplaying = ("onplaying",)
onprogress = ("onprogress",)
onpropstate = ("onpropstate",)
onratechange = ("onratechange",)
onreadystatechange = ("onreadystatechange",)
onredo = ("onredo",)
onresize = ("onresize",)
onscroll = ("onscroll",)
onseeked = ("onseeked",)
onseeking = ("onseeking",)
onselect = ("onselect",)
onstalled = ("onstalled",)
onstorage = ("onstorage",)
onsubmit = ("onsubmit",)
onsuspend = ("onsuspend",)
ontimeupdate = ("ontimeupdate",)
onundo = ("onundo",)
onunload = ("onunload",)
onvolumechange = ("onvolumechange",)
onwaiting = ("onwaiting",)
open = ("open",)
optimum = ("optimum",)
pattern = ("pattern",)
ping = ("ping",)
placeholder = ("placeholder",)
preload = ("preload",)
pubdate = ("pubdate",)
radiogroup = ("radiogroup",)
readonly = ("readonly",)
rel = ("rel",)
required = ("required",)
reversed = ("reversed",)
rows = ("rows",)
rowspan = ("rowspan",)
sandbox = ("sandbox",)
scope = ("scope",)
scoped = ("scoped",)
seamless = ("seamless",)
selected = ("selected",)
shape = ("shape",)
size = ("size",)
sizes = ("sizes",)
span = ("span",)
spellcheck = ("spellcheck",)
src = ("src",)
srcdoc = ("srcdoc",)
start = ("start",)
step = ("step",)
style = ("style",)
subject = ("subject",)
summary = ("summary",)
tabindex = ("tabindex",)
target = ("target",)
title = ("title",)
type_ = ("type",)
usemap = ("usemap",)
value = ("value",)
width = ("width",)
wrap = ("wrap",)
xmlns = ("xmlns",)

-- | These are "special"

on event = ("on" <> event,)
dataAttrib name = ("data-" <> name,)
